Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Thread Class Reference

STK thread class. More...

`#include <Thread.h>`

Inheritance diagram for stk::Thread:

## Public Member Functions
| Thread ()
| Default constructor.
| ~Thread ()
| The class destructor does not attempt to cancel or join a thread.
bool | start (THREAD_FUNCTION routine, void *ptr=NULL)
| Begin execution of the thread routine. Upon success, true is returned.
bool | cancel (void)
| Signal cancellation of a thread routine, returning true on success.
bool | wait (void)
| Block the calling routine indefinitely until the thread terminates.
void | testCancel (void)
| Create a cancellation point within a thread routine.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK thread class.

This class provides a uniform interface for cross-platform threads. On unix systems, the pthread library is used. Under Windows, the C runtime threadex functions are used.

Each instance of the Thread class can be used to control a single thread process. Routines are provided to signal cancelation and/or joining with a thread, though it is not possible for this class to know the running status of a thread once it is started.

For cross-platform compatability, thread functions should be declared as follows:

THREAD_RETURN THREAD_TYPE thread_function(void *ptr)

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Member Function Documentation

## ◆ start()

bool stk::Thread::start | ( | THREAD_FUNCTION | routine,
|  | void * | ptr = `NULL`
| ) |  |

Begin execution of the thread routine. Upon success, true is returned.

A data pointer can be supplied to the thread routine via the optional ptr argument. If the thread cannot be created, the return value is false.

## ◆ cancel()

bool stk::Thread::cancel | ( | void |  | ) |

Signal cancellation of a thread routine, returning true on success.

This function only signals thread cancellation. It does not wait to verify actual routine termination. A true return value only signifies that the cancellation signal was properly executed, not thread cancellation. A thread routine may need to make use of the testCancel() function to specify a cancellation point.

## ◆ wait()

bool stk::Thread::wait | ( | void |  | ) |

Block the calling routine indefinitely until the thread terminates.

This function suspends execution of the calling routine until the thread has terminated. It will return immediately if the thread was already terminated. A true return value signifies successful termination. A false return value indicates a problem with the wait call.

## ◆ testCancel()

void stk::Thread::testCancel | ( | void |  | ) |

Create a cancellation point within a thread routine.

This function call checks for thread cancellation, allowing the thread to be terminated if a cancellation request was previously signaled.

The documentation for this class was generated from the following file:

- Thread.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.